// wc.cpp for Laboratory 05 - "Taking a trip to the Library"
// wc counts the number of characters, words, and lines
// $Revision: 1.3 $

#include <iostream>
#include <fstream>
#include <string>
#include <ctype.h>

using namespace std;

int main() {

   // define and initialize counters

   int NbrChars = 0;
   int NbrWords = 0;
   int NbrLines = 0;

   // helping object that keeps track whether current character
   // is part of an already ongoing word.  because there is no
   // character at this point it is initialized to true

   bool InBetweenWords = true;

   // process the characters one at a time.  must read all characters
   // including whitespace

   // define input stream

   ifstream fin("words.txt");

   // define object to be the target of the extractions

   char CurrentCharacter;

   while (fin.get(CurrentCharacter)) {

      // found another character

      ++NbrChars;

      // determine whether character is whitespace or part of a word

      if ( isspace(CurrentCharacter) ) { // character is whitespace

         InBetweenWords = true;

         if (CurrentCharacter == '\n') {

            // found end of another line

            ++NbrLines;
         }
      }
      else { // character is part of a word

         // determine whether its the start of a word

         if ( InBetweenWords ) { // found a new word

            InBetweenWords = false;
            ++NbrWords;
         }
      }
   }

   // display the counts

   cout << "Chars: " << NbrChars << endl
    << "Words: " << NbrWords << endl
    << "Lines: " << NbrLines << endl ;

   // we are all done

   return 0;
}
